import os
class Config:
    #用变量配置mysql参数
    MYSQL_DIALECT = 'mysql'
    MYSQL_DIRVER = 'pymysql'
    MYSQL_NAME = 'root'
    MYSQL_PWD = 'root'
    MYSQL_HOST = 'localhost'
    MYSQL_PORT = 3306
    MYSQL_DB = 'flask_shop'
    MYSQL_CHARSET = 'utf8'

    #连接数据库
    # SQLALCHEMY_DATABASE_URI = 'mysql+pymysql://root:root@localhost:3306/shop_env?charset=utf8'
    SQLALCHEMY_DATABASE_URI = f'{MYSQL_DIALECT}+{MYSQL_DIRVER}://{MYSQL_NAME}:{MYSQL_PWD}@{MYSQL_HOST}:{MYSQL_PORT}/{MYSQL_DB}?charset={MYSQL_CHARSET}'

    #Flask-Sqlalchemy将会追踪对象的修改并且发送信号。这需要额外的内存，如果不必要的可以禁用它
    SQLALCHEMY_TRACK_MODIFICATIONS = True

    #加密（盐） 16位长度的数据
    SECRET_KEY = os.urandom(16)
    #DEBUG = True

#将配置信息提取出来，通过继承类可以创建不同的配置信息。
#开发模式
class DevelopmentConfig(Config):
    DEBUG = True
#生产模式
class ProductionConfig(Config):
    pass

#为了方便提取
config_map={
    'develop':DevelopmentConfig,
    'product':ProductionConfig
}