from flask import Flask
from flask_sqlalchemy import SQLAlchemy
from config import config_map

#连接数据库：无参数，说明先没有连接，待以下程序运行好就连接好了 
db = SQLAlchemy()

#创建应用,将app那行添加制表符
#创建app时传递参数，不同的值加载值获取不同的配置信息
def create_app(config_name):
    app = Flask(__name__)

    #获取key的value值
    obj = config_map.get(config_name)

    #将配置应用到app中，将配合放在一个类中
    app.config.from_object(obj)

    #在app创建完成时，连接好数据库，连接数据库代码可以放前面
    db.init_app(app)

    #关联app和蓝图，需要在db初始化完成后引入蓝图
    from flask_shop.user import user
    #注册蓝图
    app.register_blueprint(user)

    #为manager.py提供app
    return app

if __name__ == "__main__":
    app.run()