#从flask_shop文件夹里的user文件夹导出user蓝图
from flask_shop.user import user,user_api

#引入models
from flask_shop import models,db

from flask_shop.utils.tokens import generate_auth_token,verify_auth_token,login_required

import re

@user.route('/')
def index():
    return 'HELLO'

from flask_restful import Resource

from flask_shop.utils.message import to_dict_msg

#类继承Resource
class User(Resource):
    def get(self):
        pass
    def post(self):
        #接受models中的参数
        name = request.form.get('name')
        pwd = request.form.get('pwd')
        #确认密码
        real_pwd = request.form.get('real_pwd')
        nick_name = request.form.get('nick_name')
        phone = request.form.get('phone')
        email = request.form.get('email')
        
        # #验证数据的正确性
        # if not all([name,pwd,real_pwd]):
        #     return {'status':10000,'msg':'数据不完整'}
        # if len(name) <2:
        #     return {'status':10001,'msg':'用户名不合法'}
        # if len(pwd) <2:
        #     return {'status':10002,'msg':'密码不合法'}
        # if pwd != real_pwd:
        #     return {'status':10003,'msg':'两次密码不一致'}
        # #用正则验证手机号
        # if not re.match(r'1[345678]\d{9}',phone):
        #     return {'status':10004,'msg':'手机号不合法'}
        # if not re.match(r'^[A-Za-z0-9\u4e00-\u9fa5]+@[a-zA-Z0-9_-]+(\.[a-zA-Z0-9_-]+)+$',email):
        #     return {'status':10004,'msg':'邮箱不合法'}
        
        # #如果数据库中已经有此值了，需要报错，所以加入try
        # try:
        #     #增加数据，注意密码赋值是直接给password
        #     usr = models.User(name=name,password=pwd,nick_name=nick_name,
        #     phone=phone,email=email)

        #     #想数据库中保存
        #     db.session.add(usr)
        #     db.session.commit()
        # except Exception:
        #     return {'status':2000,'msg':'异常错误'}
        
        # return {'status':200,'msg':'登录成功'}

        #验证数据的正确性
        if not all([name,pwd,real_pwd]):
            return to_dict_msg(10000)
        if len(name) <2:
            return to_dict_msg(10001)
        if len(pwd) <2:
            return to_dict_msg(10002)
        if pwd != real_pwd:
            return to_dict_msg(10003)
        #用正则验证手机号
        if not re.match(r'1[345678]\d{9}',phone):
            return to_dict_msg(10004)
        if not re.match(r'^[A-Za-z0-9\u4e00-\u9fa5]+@[a-zA-Z0-9_-]+(\.[a-zA-Z0-9_-]+)+$',email):
            return to_dict_msg(10005)
        
        #如果数据库中已经有此值了，需要报错，所以加入try
        try:
            #增加数据，注意密码赋值是直接给password
            usr = models.User(name=name,password=pwd,nick_name=nick_name,
            phone=phone,email=email)

            #想数据库中保存
            db.session.add(usr)
            db.session.commit()
            return to_dict_msg(200)
        except Exception:
            return to_dict_msg(2000)
        

#给User增加url地址
user_api.add_resource(User,'/user')

from flask import request

#post方法比较安全
@user.route('/login',methods=['POST'])
#路由处引入装饰器
# @login_required
def login():
    name = request.form.get('name')
    pwd = request.form.get('pwd')

    #为了降低数据库的负担，在传给数据库之前做判断
    #判断输入的数据是否全是真值,有一个假值就会报错
    if not all([name,pwd]):
        #返回错误信息
        return {'status':10000,'msg':'数据不完整'}
    #判断是否是正确信息
    if len(name)>1:
        usr = models.User.query.filter_by(name = name).first()
        #如果有值则用户名成功
        if usr:
            #判断密码是否正确
            if usr.check_password(pwd):
                #登录成功后产生token
                token = generate_auth_token(usr.id,1000000)
                verify_auth_token(token)
                # return {'status':200,'msg':'登录成功'}
                #以上返回成功可写成如下，数据是token,用户再次登录可携带token
                return to_dict_msg(200,data={'token':token})
    
    #任何一个if不满足就返回此错误信息
    return {'status':10001,'msg':'用户名或密码错误'}

@user.route('/test')
# @login_required
def test_login_req():
    return to_dict_msg(200)
         