#从flask_shop中引入create_app方法
from flask_shop import create_app,db
from flask_migrate import Migrate,MigrateCommand
from flask_script import Manager

#将key值作为参数传递进去
app = create_app('develop')

#创建对象
manager = Manager(app)
#同步数据库对象
Migrate(app,db)
#创建命令
manager.add_command('db',MigrateCommand)

"""
python manager.py db init   执行一次

python manager.py db migrate    生成表结构

python manager.py db upgrade    映射数据库

今后如果需要反复更新、修改、增加数据只需要执行后两个

注意：main一定写的是manager.run()

写成manager.run()如何运行项目（两个方式)
 1、改为app.run()
 2、终端输入python manager.py runserver

"""

if __name__ == "__main__":
    #运行项目
    app.run()

    #manager已经创建了迁移数据的命令db
    #为flask创建的管理命令
    # manager.run()